每天一道leetcode:剑指 Offer 12. 矩阵中的路径(中等&DFS深度优先遍历)

今日份题目:

给定一个 `m x n` 二维字符网格 `board` 和一个字符串单词 `word` 。如果 `word` 存在于网格中,返回 `true` ;否则,返回 `false` 。

单词必须按照字母顺序,通过相邻的单元格内的字母构成,其中"相邻"单元格是那些水平相邻或垂直相邻的单元格。同一个单元格内的字母不允许被重复使用。

例如,在下面的 3×4 的矩阵中包含单词 "ABCCED"(单词中的字母已标出)。

示例1

复制代码
输入:board = [["A","B","C","E"],["S","F","C","S"],["A","D","E","E"]], word = "ABCCED"
输出:true

示例2

复制代码
输入:board = [["a","b"],["c","d"]], word = "abcd"
输出:false

提示

  • m == board.length

  • n = board[i].length

  • 1 <= m, n <= 6

  • 1 <= word.length <= 15

  • board和word仅由大小写英文字母组成

题目思路

DFS深度优先遍历,重点在于一次次的dfs递归调用。由于不知道从哪个位置开始遍历,所以遍历矩阵中所有的位置,在与字符串第一个字母相同的点开始dfs遍历判断是否有满足条件的情况。

dfs的具体过程:递归结束条件,如果中间某个位置的字母与字符串当前的字母不同,就返回false,如果字符串遍历完了,说明存在字符串,返回true。剩下的情况,需要遍历四个方向查看有无满足条件的下个位置,如果所有都有,就返回true,否则返回false。

代码

cpp 复制代码
class Solution 
{
public:
    bool dfs(vector<vector<char>>& board,vector<vector<int>>& visited,int i,int j,string& s,int k) 
    {
        if(board[i][j]!=s[k]) return false;
        else if(k==s.length()-1) return true;//遍历完字符串s了,说明存在字符串s
        visited[i][j]=1;//标记当前位置为已到过
        vector<pair<int,int> > directions{{0,1},{0,-1},{1,0},{-1,0}};//标记四个方向
        bool result=false;
        for(const auto& dir:directions) //遍历四个方向
        {
            int ii=i+dir.first,jj=j+dir.second;//新的位置
            if(ii>=0&&ii<board.size()&&jj>=0&&jj<board[0].size()) 
            {
                if(!visited[ii][jj]) //当前位置还未到过
                {
                    bool res=dfs(board,visited,ii,jj,s,k+1);//继续遍历下一个位置
                    if(res) //为真,说明四个方向中找到正确的位置,返回真
                    {
                        result=true;
                        break;
                    }
                }
            }
        }
        visited[i][j]=0;//注意:标记为0,未遍历过,便于其他情况的遍历
        return result;
    }

    bool exist(vector<vector<char>>& board, string word) 
    {
        int n=board.size(),m=board[0].size();
        vector<vector<int>> visited(n,vector<int>(m));
        for(int i=0;i<n;i++) //遍历矩阵的行
        {
            for(int j=0;j<m;j++) //遍历矩阵的列
            {
                if(board[i][j]==word[0])
                {
                    bool flag=dfs(board,visited,i,j,word,0);
                	if(flag) return true;//以当前位置为起点可以找到字母
                }
            }
        }
        return false;
    }
};

提交结果

欢迎大家在评论区讨论,如有不懂的代码部分,欢迎在评论区留言!

相关推荐
Shadow(⊙o⊙)几秒前
C++11并发支持库
开发语言·c++
飘尘3 分钟前
从"算子"到"AI Infra":大模型背后看不见的那群人在忙什么
人工智能·算法·面试
ychqsq10 分钟前
212.涟漪
经验分享·职场和发展
ychqsq12 分钟前
213.取舍
经验分享·职场和发展
ShineWinsu12 分钟前
对于Redis:主从复制的解析
linux·数据库·c++·redis·缓存·面试·主从复制
mokongJ35 分钟前
17 份异构销售数据的合并清洗方案:30 万行处理耗时 9.64 秒
数据结构
夏幻灵42 分钟前
每日一题:LeetCode 3:无重复字符的最长子串——滑动窗口思路详解
算法·leetcode·职场和发展
CarIise1 小时前
Java实训阶段查漏补缺复习笔记2
java·linux·算法
无忧.芙桃1 小时前
C++ 并查集详解:原理、实现与应用
c语言·c++·算法·leetcode
蛋蛋的就会顺顺的1 小时前
hot100——二叉树
java·数据结构·算法·leetcode·力扣